Subject: Re: [syzbot] [net?] [v9fs?] KCSAN: data-race in p9_fd_create / p9_fd_create (2)

From: Marco Elver <[email-masked]>
Date: Wed, 30 Aug 2023 09:59:30 +0200

On Wed, Aug 30, 2023 at 08:05AM +0900, Dominique Martinet wrote:
> Marco Elver wrote on Tue, Aug 29, 2023 at 04:11:38PM +0200:
> > On Tue, Aug 29, 2023 at 07:57PM +0900, Dominique Martinet wrote:
> > [...]
> > > Yes well that doesn't seem too hard to hit, both threads are just
> > > setting O_NONBLOCK to the same fd in parallel (0x800 is 04000,
> > > O_NONBLOCK)
> > > 
> > > I'm not quite sure why that'd be a problem; and I'm also pretty sure
> > > that wouldn't work anyway (9p has no muxing or anything that'd allow
> > > sharing the same fd between multiple mounts)
> > > 
> > > Can this be flagged "don't care" ?
> > 
> > If it's an intentional data race, it could be marked data_race() [1].
> > [1] https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/tree/tools/memory-model/Documentation/access-marking.txt
> 
> Thanks!
> 
> > However, staring at this code for a bit, I wonder why the f_flags are
> > set on open, and not on initialization somewhere...
> 
> This open is during the mount initialization (mount/p9_client_create,
> full path in the stack); there's no more initialization-ish code we
> have.
> The problem here is that we allow to pass any old arbitrary fd, so the
> user can open their fd how they want and abuse mount to use it on
> multiple mounts, even if that has no way of working (as I mentionned,
> there's no control flow at all -- you'll create two completely separate
> client state machines that'll both try to read and/or write (separate
> fds) on the same fd, and it'll all get jumbled up.
> > 
> > Anyway, a patch like the below would document that the data race is
> > intended and we assume that there is no way (famous last words) the
> > compiler or the CPU can mess it up (and KCSAN won't report it again).
> 
> That's good enough for me as my position really is just "don't do
> that"... Would that also protect from syzcaller sending the fd to mount
> on one side, and calling fcntl(F_SETFL) on the side?

No, data_race() is only for marking intentional data races. In a
production kernel, it's a no-op (generated code is identical). In a
KCSAN kernel, it will make the tool not report such data races.

syzkaller doesn't care, and can still produce such programs (so that
other bug detectors can still see an issue if there is one somewhere).

> At this rate we might as well just take the file's f_lock as setfl does,
> but perhaps there's a way to steal the fd from userspace somehow?
> 
> It's not just "don't use this fd for another mount", it really is "don't
> use this fd anymore while it is used by a mount".
> 
> This is made complicated that we only want to steal half of the fd, you
> could imagine a weird setup like this:
> 
>  ┌────────────────────────────────────┐         ┌─────────────────┐
>  │                                    │         │                 │
>  │                                    │         │  kernel client  │
>  │   fd3 tcp to server                │         │                 │
>  │       write end  ◄─────────────────┼─────────┤                 │
>  │                                    │         │                 │
>  │       read end   ──┐               │         │                 │
>  │                    │               │         │                 │
>  │   fd4 pipeA        │ MITMing...    │         │                 │
>  │                    │               │         │                 │
>  │       write end  ◄─┘               │         │                 │
>  │                                    │         │                 │
>  │   fd5 pipeB                        │         │                 │
>  │                                    │         │                 │
>  │       read end  ───────────────────┼────────►│                 │
>  │                                    │         │                 │
>  │                                    │         │                 │
>  └────────────────────────────────────┘         └─────────────────┘
> 
> I'm not sure we actually want to support something like that, but it's
> currently possible and making mount act like close() on the fd would
> break this... :|
> 
> So, yeah, well; this is one of these "please don't do this" that
> syzcaller has no way of knowing about; it's good to test (please don't
> do this has no security guarantee so the kernel shouldn't blow up!),
> but if the only fallout is breakage then yeah data_race() is fine.

Right, if the only breakage is some corruption of the particular file in
user space, and the kernel is still in a good state, then I think this
is fine. However, if the kernel can potentially crash or corrupt
completely unrelated data, it may be a problem.

> Compilers and/or CPU might be able to blow this out of proportion, but
> hopefully they won't go around modifying another unrelated value in
> memory somewhere, and we do fdget so it shouldn't turn into a UAF, so I
> guess it's fine?...

No, the kernel strongly assumes "locally undefined behaviour" for data
races in the worst case, i.e. some garbage value being written into
f_flags. To guard against that we'd have to use READ_ONCE/WRITE_ONCE.

But given the best-effort nature of this based on "don't do this" i.e.
not really supported, data_race() is probably more than enough. You may
want to amend the patch I sent to clarify that (I wasn't aware of it).

> Just taking f_lock here won't solve anything and
> might give the impression we support concurrent uses.
> 
> 
> Sorry for rambling, and thanks for the patch; I'm not sure if Eric has
> anything planned for next cycle but either of us can take it and call it
> a day.

Thanks for the explanation!